;***************************************************************************
;* Equations for MP3-CD code
;***************************************************************************

SCL           equ 0
SDA 	      equ 1
HAB_DEC       equ 3
DEM 	      equ 5
READ_RAM      equ 0
WRITE_RAM     equ 1
E_LCD         equ 4
RSn           equ 0
RWn           equ 1  
KEY1          equ 0
KEY2          equ 1
KEY3          equ 2
KEY4          equ 3
KEY5          equ 4
KEY_IN        equ 2
IIS_MAS       equ 5
SIC           equ 6
SID           equ 7
RESET_MASDAC  equ 6
READ_IDE      equ 3
WRITE_IDE     equ 2
D_STATUS      equ b'00010111'
D_STATUS_A    equ b'00001110'
D_COMMAND     equ D_STATUS
D_CILYNDER_H  equ b'00010101'
D_CILYNDER_L  equ b'00010100'
D_SECTOR_N    equ b'00010011'
D_SECTOR_C    equ b'00010010'
D_DEVICE_H    equ b'00010110'
D_FEATURES    equ b'00010001'
D_ERRORR      equ D_FEATURES
D_DATA_R      equ b'00010000'
D_DEVICE_C    equ D_STATUS_A




STATUS_R      equ		h'20'
STATUS_A      equ		h'21'
COMMAND       equ		h'22'
CILYNDER_H    equ		h'23'
CILYNDER_L    equ		h'24'
SECTOR_N      equ		h'25'
SECTOR_C      equ		h'26'
DEVICE_H      equ		h'27'
FEATURES      equ		h'28'
ERRORR        equ		h'29'
DEVICE_C      equ		h'2A'
DATA_RL       equ		h'2B'
DATA_RH       equ		h'2C'
;**********************************************************
;**********************************************************
         ; FLAGs
FLAG_CD       equ		h'2D'
         ; FLAG_CD  d7 d6 d5 d4  d3  d2  d1   d0
         ;          xx DA RO ST Pau Pre LoEj Start   
         ;                               0     0      Stop Disc
         ;                               0     1      Start Disc , read TOC
         ;                               1     0      Eject Disc 
	 ;                               1     1      Load Disc
         ;                           0   xx    xx     Allow Eject 
         ;                           1   xx    xx     Prevent Eject 
         ;                       0   xx  xx    xx     Pause
         ;                       1   xx  xx    xx     Resume
         ;                   0   xx  xx  xx    xx     Hay CD Cargado
         ;                   1   xx  xx  xx    xx     No hay CD Cargado
         ;             0  1  xx  xx  xx  xx    xx     CD-ROM
         ;             1  0  xx  xx  xx  xx    xx     CD-DA
         ;             1  1  xx  xx  xx  xx    xx     CD-HYBRID    
         ;
FLAG_KEY      equ		h'2E'
         ; FLAG_KEY   d7 d6 d5  d4   d3  d2  d1   d0    
         ;            xx xx xx MODE STOP FRD REW PLAY
FLAG_KEY1     equ		h'2F'
         ; FLAG_KEY1  d7 d6 d5  d4   d3  d2  d1   d0    
         ;            xx xx xx MODE STOP FRD REW PLAY

FLAG_STATE    equ		h'30'
         ; FLAG_STATE d7 d6   d5   d4    d3   d2  d1  d0                                                 
         ;                        MODE  EJECT    REW PAUSE                       
PLAY          equ 0
REW           equ 1
FRD           equ 2
STOP          equ 3
MODE          equ 4
PAUSE         equ 0
EJECT         equ 3
;**********************************************************
;**********************************************************
         ; VARIABLES y CONSTATES                     
             
         ; STATUS REGISTER
BSY           equ 7
DRDY          equ 6
DRQ           equ 3
ERR           equ 0
         ; ERROR REGISTER
ABRT          equ 2
         ; DEVICE CONTROL REGISTER
SRST          equ 2
nEIN          equ 1
         ; PKT COMMAND    
BP0           equ		h'31'
BP1           equ		h'32'
BP2           equ		h'33'
BP3           equ		h'34'
BP4           equ		h'35'
BP5           equ		h'36'
BP6           equ		h'37'
BP7           equ		h'38'
BP8           equ		h'39'
BP9           equ		h'3A'
BP10          equ		h'3B'
BP11          equ		h'3C'

ADR_RL        equ		h'3D'
ADR_RH        equ		h'3E'
ADR_WL        equ		h'3F'
ADR_WH        equ		h'40'
TOPE          equ		h'41'
BYTERAM       equ		h'42'
START_M       equ		h'43'
START_S       equ		h'44'
START_F       equ		h'45'
END_M         equ		h'46'
END_S         equ		h'47'
END_F         equ		h'48'
LBA_1         equ		h'49'
LBA_2         equ		h'4A'
LBA_3         equ		h'4B'
LBA_4         equ		h'4C'
TRANS_1       equ		h'4D'
TRANS_2       equ		h'4E'
TRANS_3       equ		h'4F'  
TRANS_4       equ		h'50' 
INDEX         equ		h'51'
INDEX_LIST    equ		h'52'
TOTAL_SONG    equ		h'53'
TOTAL_LIST    equ		h'54'
VOLUMEN       equ		h'55'
BASS          equ		h'56'
TREBLE        equ		h'57'
PRE           equ		h'58'
CONTROL       equ		h'59'

CONT1         equ		h'5A' 
CONT2         equ		h'5B'  
TEMPW         equ		h'5C'
TEMP1         equ		h'5D'
TEMP2         equ		h'5E'
TEMP3         equ		h'5F'
TEMP4         equ		h'60'
TEMP5         equ		h'61'
BASEF         equ		h'62'

ACC1	      equ		h'66'
ACC2          equ		h'67' 

FLAG          equ		h'68'
ATAPIn        equ 0
JOULIET       equ 1
ACK           equ 2
MANTIENE      equ 3
FINALMP3      equ 4
FINALMP31     equ 5
MARCA1        equ 6
MARCA2        equ 7
;**********************************************************
;**********************************************************
          ; LCD

REG_LCD       equ		h'69'
COUNTER       equ		h'6A'
COUNTER1      equ		h'6B'
MESSAJE       equ		h'6C'
MESSAJE1      equ		h'6D'
;**********************************************************
;**********************************************************
          ; BCD

COUNTER2      equ		h'6E'
L_BYTE        equ		h'6F'
DECENA        equ		h'70' 
MILENA        equ		h'71'
DIG_1         equ		h'72'
DIG_2         equ		h'73'
DIG_3         equ		h'74'
;**********************************************************
;**********************************************************
          ; I2C
BYTEIIC       equ		h'75'
BUFFERIIC     equ		h'76'
N_BYTEIIC     equ		h'7C'
I2C_COUNT     equ		h'7D'
I2C_FAIL      equ		h'7E'
MIKE_TEMPW    equ		h'7F'

          ; Macros

sdaup         MACRO
              bsf STATUS,RP0
              bsf TRISA,SDA
              bcf STATUS,RP0
              ENDM

sclup         MACRO
              bsf STATUS,RP0
              bsf TRISA,SCL
              bcf STATUS,RP0
              ENDM

sdadown       MACRO
              bsf STATUS,RP0
              bcf TRISA,SDA
              bcf STATUS,RP0
              ENDM

scldown       MACRO
              bsf STATUS,RP0
              bcf TRISA,SCL
              bcf STATUS,RP0
              ENDM

;***************************************************************************
;* Equations for MP3-HDD code
;***************************************************************************

; IR button hold time
IR_HOLD_TIME		equ	d'3'


; default settings... 0 to 31
DEFAULT_VOLUME		equ	d'16'
DEFAULT_TREBLE		equ	d'16'
DEFAULT_BASS		equ	d'16'

; modes
MODE_VOL			equ	d'0'
MODE_POS			equ	d'1'
MODE_TRK			equ	d'2'
MODE_CD			equ	d'3'
MODE_TRB			equ	d'4'
MODE_BAS			equ	d'5'

; virtual button codes
VB_NOBUTTON			equ	d'0'
VB_PLAYSTOP			equ	d'1'
VB_VOL_PLUS			equ	d'2'
VB_VOL_MINUS		equ	d'3'
VB_POS_PLUS			equ	d'4'
VB_POS_MINUS		equ	d'5'
VB_TRK_PLUS			equ	d'6'
VB_TRK_MINUS		equ	d'7'
VB_CD_PLUS			equ	d'8'
VB_CD_MINUS			equ	d'9'
VB_TRB_PLUS			equ	d'10'
VB_TRB_MINUS		equ	d'11'
VB_BAS_PLUS			equ	d'12'
VB_BAS_MINUS		equ	d'13'
VB_PLUS			equ	d'14'
VB_MINUS			equ	d'15'
VB_MODE			equ	d'16'


; SRAM locations
SRAM_ADDR_FAT		equ	h'0000'			; 0-511
SRAM_ADDR_CDHDR		equ	h'0200'			; 512-1023
SRAM_ADDR_TRKHDR		equ	h'0400'			; 1024-2047
SRAM_ADDR_LCD		equ	h'0800'			; 2048-2559
SRAM_ADDR_FSHDR		equ	h'0a00'			; 2560
SRAM_ADDR_IRTABLE		equ	h'0c00'			; follows header sector

; offsets within FS header sector
HDROFFSET_MAGIC		equ	d'0'
HDROFFSET_VERSION		equ	d'4'
HDROFFSET_COPYRIGHT	equ	d'8'
HDROFFSET_FATSTART	equ	d'32'
HDROFFSET_FATCOUNT	equ	d'36'
HDROFFSET_DATASTART	equ	d'40'
HDROFFSET_DATACOUNT	equ	d'44'
HDROFFSET_CDSTART		equ	d'48'
HDROFFSET_CDCOUNT		equ	d'52'

; offsets within cd header sector
CDHDROFFSET_MAGIC		equ	d'0'
CDHDROFFSET_TRKCOUNT	equ	d'4'
CDHDROFFSET_TITLE		equ	d'16'
CDHDROFFSET_ARTIST	equ	d'64'
CDHDROFFSET_TRKCLUSTERS	equ	d'112'

; offsets within track header sector
TRKHDROFFSET_MAGIC	equ	d'0'
TRKHDROFFSET_LEN		equ	d'4'
TRKHDROFFSET_TITLE	equ	d'8'
TRKHDROFFSET_ARTIST	equ	d'56'
TRKHDROFFSET_RESERVED	equ	d'104'
TRKHDROFFSET_INDEX	equ	d'128'

; PORTE demux lines
DEMUX_SRAM_RD		equ		d'0'
DEMUX_SRAM_WR		equ		d'1'
DEMUX_IDE_RD		equ		d'3'
DEMUX_IDE_WR		equ		d'2'
DEMUX_LCD			equ		d'4'
DEMUX_LATCH_RDWR		equ		d'5'

; PORTA bits
I2CC				equ		d'0'
I2CD				equ		d'1'
BUTTON_CTRL			equ		d'2'
ENABLE			equ		d'3'
IR_INPUT			equ		d'4'
MAS_DEMAND			equ		d'5'

; IDE registers
IDE_REG_ALTSTATUS		equ		d'14'
IDE_REG_CTRL		equ		d'14'

IDE_REG_DATA		equ		d'16'
IDE_REG_ERROR	   	equ		d'17'
IDE_REG_FEATURES		equ		d'17'
IDE_REG_SECTORCOUNT	equ		d'18'
IDE_REG_SEC0		equ		d'19'
IDE_REG_SEC1			equ		d'20'
IDE_REG_SEC2			equ		d'21'
IDE_REG_DEVHEAD			equ		d'22'
IDE_REG_STATUS			equ		d'23'
IDE_REG_CMD			equ		d'23'

; we use 16x512-byte sectors per cluster, giving 8KB clusters
SECTORS_PER_CLUSTER		equ		d'16'

; CUR_STATUS bits
CS_LASTDATA			equ		d'0'		; last tune data read
CS_TUNEDONE			equ		d'1'		; last tune data sent
CS_IDEBUSY			equ		d'2'		; IDE drive in use
CS_STREAMOK			equ		d'3'		; streaming enabled
CS_IRDATAREADY			equ		d'4'		; data received by IR
CS_SKIPHEADER			equ		d'5'		; start of tune?

; LCD/UI bits
LCD_INT				equ		d'0'		; int occurred?
LCD_20HZ_INT			equ		d'1'		; 20Hz timer?
LCD_MSG_SOZ			equ		d'2'		; reset scroll offset?
LCD_SCROLL			equ		d'3'		; scroll required
LCD_I2CBUSY			equ		d'4'		; I2C busy?
LCD_TIMEUPDATE			equ		d'5'		; song timer update?
LCD_BACKLIGHT_ON_OFF		equ		d'6'		; status of backlight (1=ON)

;*
;* registers
;*

; W_BKP defined in both banks
W_BKP				equ		h'20'

; FAT start sector (LBA mode)
FAT_START_0			equ		h'21'
FAT_START_1			equ		h'22'
FAT_START_2			equ		h'23'
FAT_START_3			equ		h'24'

; DATA start cluster
DATA_START_LO			equ		h'25'
DATA_START_MID			equ		h'26'
DATA_START_HI			equ		h'27'

; current FAT sector cached in SRAM
CUR_FAT_CACHED_LO		equ		h'28'
CUR_FAT_CACHED_HI		equ		h'29'

; current status bitfield
CUR_STATUS			equ		h'2a'

; the current IDE cluster being fetched/read
CUR_CLUSTER_LO			equ		h'2b'
CUR_CLUSTER_MID			equ		h'2c'
CUR_CLUSTER_HI			equ		h'2d'

; current index position
CUR_INDEX			equ		h'2e'

; next index cluster
NEXT_CLUSTER_LO			equ		h'2f'
NEXT_CLUSTER_MID		equ		h'30'
NEXT_CLUSTER_HI			equ		h'31'

; current block within cluster to be read next
CUR_BLOCK			equ		h'32'
	
; SRAM info
SRAM_WRITE_LO			equ		h'33'
SRAM_WRITE_HI			equ		h'34'
SRAM_READ_LO			equ		h'35'
SRAM_READ_HI			equ		h'36'
SRAM_COUNT_LO			equ		h'37'
SRAM_COUNT_HI			equ		h'38'

; IDE sector version of CUR_CLUSTER
IDE_SEC0			equ		h'39'
IDE_SEC1			equ		h'3a'
IDE_SEC2			equ		h'3b'
IDE_SEC3			equ		h'3c'

; SRAM ptrs for RAM transfers
SRAM_HI				equ		h'3d'
SRAM_LO				equ		h'3e'
SEC_CT				equ		h'3f'

; PC data exhange
PC_RECV_0			equ		h'40'
PC_RECV_1			equ		h'41'
PC_SEND				equ		h'42'

; IR regs
IR_DATA_LO			equ		h'43'
IR_DATA_HI			equ		h'44'
IR_BITCOUNT			equ		h'45'
IR_LOTIME			equ		h'46'
IR_RECV_LO			equ		h'47'
IR_RECV_HI			equ		h'48'

; status reg bkp - only needs to be defined in one bank
STATUS_BKP			equ		h'49'

; LCD timing status
LCD_STATUS			equ		h'4a'
LCD_OFFSET			equ		h'4b'
LCD_CURSOR			equ		h'4c'
LCD_ROW_CTR			equ		h'4d'

; user-interface stuff
CTR_20HZ			equ		h'4e'
CUR_BUTTON			equ		h'4f'
IR_RELEASE			equ		h'50'
BUTTON_TIME			equ		h'51'
CUR_MODE			equ		h'52'
PROC_BUTTON			equ		h'53'
SCROLL_OFFSET			equ		h'54'
SCROLL_TIMER			equ		h'55'

; current CD and track
CUR_CDLO			equ		h'56'
CUR_CDHI			equ		h'57'
CUR_TRACK			equ		h'58'

; port C shadow 'cos latch is transparent - have to preserve value for PC
SHADOW_C			equ		h'59'
OLD_STATUS			equ		h'5a'

; button timeout
BUTTON_TIMEOUT			equ		h'5b'

; tmp regs
TMP0				equ		h'5c'
TMP1				equ		h'5d'
TMP2				equ		h'5e'
CTR				equ		h'5f'

; transfer buffer
TRANS_BUFFER			equ		h'60'

TMP_LO				equ		h'61'
TMP_HI				equ		h'62'

; bank1 registers
;W_BKP				equ		h'a0'

I2C_CTR				equ		h'a1'
I2C_MSGLEN			equ		h'a2'
I2C_MSGPOS			equ		h'a3'
I2C_RESPONSE			equ		h'a4'
I2C_BYTE			equ		h'a5'
I2C_MSG				equ		h'a6'	; a6,7,8,9,a,b...

TIME_19TH			equ		h'ac'
TIME_SEC			equ		h'ad'
TIME_MIN			equ		h'ae'

CUR_VOLUME			equ		h'af'
CUR_TREBLE			equ		h'b0'
CUR_BASS			equ		h'b1'

TMP_PAGE1			equ		h'b2'




